POJ 3615 Cow Hurdles (Floyd算法)

Cow Hurdles

Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 6142   Accepted: 2752

Description

Farmer John wants the cows to prepare for the county jumping competition, so Bessie and the gang are practicing jumping over hurdles. They are getting tired, though, so they want to be able to use as little energy as possible to jump over the hurdles.

Obviously, it is not very difficult for a cow to jump over several very short hurdles, but one tall hurdle can be very stressful. Thus, the cows are only concerned about the height of the tallest hurdle they have to jump over.

The cows‘ practice room has N (1 ≤ N ≤ 300) stations, conveniently labeled 1..N. A set of M (1 ≤ M ≤ 25,000) one-way paths connects pairs of stations; the paths are also conveniently labeled 1..M. Path itravels
from station Si to station Ei and contains exactly one hurdle of height Hi (1 ≤ Hi ≤ 1,000,000). Cows must jump hurdles in any path they traverse.

The cows have T (1 ≤ T ≤ 40,000) tasks to complete. Task i comprises two distinct numbers, Ai and Bi (1 ≤ Ai ≤ N; 1 ≤ Bi ≤ N), which
connote that a cow has to travel from station Ai to station Bi (by traversing over one or more paths over some route). The cows want to take a path the minimizes the height of the tallest hurdle they jump over when traveling
from Ai to Bi . Your job is to write a program that determines the path whose tallest hurdle is smallest and report that height.

 

Input

* Line 1: Three space-separated integers: NM, and T

* Lines 2..M+1: Line i+1 contains three space-separated integers: Si , Ei , and Hi

* Lines M+2..M+T+1: Line i+M+1 contains two space-separated integers that describe task i: Ai and Bi

Output

* Lines 1..T: Line i contains the result for task i and tells the smallest possible maximum height necessary to travel between the stations. Output -1 if it is impossible to travel between the two stations.

Sample Input

5 6 3
1 2 12
3 2 8
1 3 5
2 5 3
3 4 4
2 4 8
3 4
1 2
5 1

Sample Output

4
8
-1

Source

USACO 2007 November Silver

题意:有一头牛,要进行跳木桩训练,已知有n个木桩,而且知道m对木桩之间的高度差。但是它很懒,它想尽可能的跳最小的高度就完成从任意一个木桩到任意一个木桩的跳跃,给m对点,问是否存在最小的跳跃高度使得其能够完成跳跃,如果有就输出最小高度;否则输出-1。

解析:现在要记录路径“长度”,实际上是最大跳跃高度,说白了就是,这条路径上所经过的相邻两木桩之间的差值的最大值,因为只要能跳过这个高度差最大的,高度差小的当然能跳过去了。由于是求任意两木桩之间的最大高度差值的最小值,所以我们可以用Floyd算法,对其进行处理,处理之后得到的最终结果就是最大高度的最小值了。

AC代码:

#include <cstdio>
#include <iostream>
#include <algorithm>
using namespace std;
#define INF 123456789
int a[302][302];        //最大高度的最小值矩阵

int main(){
    int n, m, t;
    int x, y, w;
    while(scanf("%d%d%d", &n, &m, &t)!=EOF){
        for(int i=1; i<=n; i++)                 //初始化
            for(int j=1; j<=n; j++) a[i][j] = i==j ? 0 : INF;
        for(int i=1; i<=m; i++){                //读入高度差
            scanf("%d%d%d", &x, &y, &w);
            a[x][y] = min(a[x][y], w);          //更新最大高度差
        }
        for(int k=1; k<=n; k++)                 //Floyd
            for(int i=1; i<=n; i++)
                for(int j=1; j<=n; j++){
                    a[i][j] = min(a[i][j], max(a[i][k], a[k][j]));
                }
        for(int i=1; i<=t; i++){
            scanf("%d%d", &x, &y);
            printf("%d\n", a[x][y]==INF ? -1 : a[x][y]);       //输出,如果还是INF,那就代表不可达,两者时之间没有路径满足要求
        }
    }
    return 0;
}
时间: 2024-08-07 08:37:56

POJ 3615 Cow Hurdles (Floyd算法)的相关文章

ACM: POJ 3660 Cow Contest - Floyd算法

链接 Cow Contest Time Limit:1000MS     Memory Limit:65536KB     64bit IO Format:%lld & %llu Description N (1 ≤ N ≤ 100) cows, conveniently numbered 1..N, are participating in a programming contest. As we all know, some cows code better than others. Eac

POJ 3615 Cow Hurdles

http://poj.org/problem?id=3615 floyd 最短路径的变形 dist[i][j]变化为 : i j之间的最大边 那么输入的时候可以直接把dist[i][j] 当作i j 之间的边进行输入 转移方程 dist[i][j] = max(dist[i][j], min(dist[i][k], dist[k][j])) 1 #include <iostream> 2 #include <string.h> 3 #include <stdio.h>

POJ 1125 Stockbroker Grapevine (Floyd算法)

Floyd算法计算每对顶点之间的最短路径的问题 题目中隐含了一个条件是一个人可以同时将谣言传递给多个人 题目最终的要求是时间最短,那么就要遍历一遍求出每个点作为源点时,最长的最短路径长是多少,再求这些值当中最小的是多少,就是题目所求 #include<bits/stdc++.h> using namespace std; int n,x,p,t; int m[120][120],dist[120][120],Max[120]; void floyd(int n,int m[][120],int

POJ 3613 Cow Relays (Floyd + 矩阵快速幂 + 离散化 神题!)

Cow Relays Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 5611   Accepted: 2209 Description For their physical fitness program, N (2 ≤ N ≤ 1,000,000) cows have decided to run a relay race using the T (2 ≤ T ≤ 100) cow trails throughout

【POJ 3615】Cow Hurdles

Cow Hurdles Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 6486   Accepted: 2948 Description Farmer John wants the cows to prepare for the county jumping competition, so Bessie and the gang are practicing jumping over hurdles. They are

poj 3660 Cow Contest(warshall算法)

poj 3660 Cow Contest Description N (1 ≤ N ≤ 100) cows, conveniently numbered 1..N, are participating in a programming contest. As we all know, some cows code better than others. Each cow has a certain constant skill rating that is unique among the co

POJ3615 Cow Hurdles【Floyd】

Cow Hurdles Time Limit: 1000MS Memory Limit: 65536K Total Submissions: 6155 Accepted: 2760 Description Farmer John wants the cows to prepare for the county jumping competition, so Bessie and the gang are practicing jumping over hurdles. They are gett

POJ 3613 Cow Relays (floyd + 矩阵快速幂)

题目大意: 求刚好经过K条路的最短路 我们知道如果一个矩阵A[i][j] 表示表示 i-j 是否可达 那么 A*A=B  B[i][j]  就表示   i-j 刚好走过两条路的方法数 那么同理 我们把i-j 的路径长度存到A 中. 在A*A的过程中,不断取小的,那么最后得到的也就是i - j 走过两条路的最短路了. 当然也是利用到了floyd的思想. 然后要求出K次的最短路,那么就是矩阵快速幂的工作了. 注意要离散化.用map #include <cstdio> #include <io

BZOJ 1641: [Usaco2007 Nov]Cow Hurdles 奶牛跨栏( floyd )

直接floyd.. ---------------------------------------------------------------------------- #include<cstdio> #include<cstring> #include<algorithm> #include<iostream> #define rep( i , n ) for( int i = 0 ;  i < n ; ++i ) #define clr( x